#define LARGE_WIDTH 15
#define LARGE_HEIGHT 18

#define SMALL_WIDTH 10
#define SMALL_HEIGHT 12

#define VTTimeout 60000


#define VT_LARGE_BITMAP_HEIGHT (LARGE_HEIGHT*25)
#define VT_LARGE_BITMAP_WIDTH (LARGE_WIDTH*40)

#define VT_SMALL_BITMAP_HEIGHT (SMALL_HEIGHT*25)
#define VT_SMALL_BITMAP_WIDTH (SMALL_WIDTH*40)


#define ROUNDUP(w) (((w)+3)&~3)
#define _BitmapDataP(bmp)	(bmp->bmiHeader.biBitCount==8?(((BYTE*)(bmp))+sizeof(BITMAPINFOHEADER)+sizeof(WORD)*256):(((BYTE*)(bmp))+sizeof(BITMAPINFOHEADER)))
#define _BitmapDataR(bmp)	(((BYTE*)(bmp))+sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*256)
#define _BitmapPalR(bmp)	((RGBQUAD*)(((BYTE*)(bmp))+sizeof(BITMAPINFOHEADER)))

#define _BitmapLargeRowR(bmp,row) (_BitmapDataR(bmp)+ROUNDUP(bmp->bmiHeader.biWidth)*(bmp->bmiHeader.biHeight-(row)*LARGE_HEIGHT))
#define _BitmapLargeChar(bmp,c)	(_BitmapLargeRowR(bmp,(c)/32)+((c)&0x1f)*LARGE_WIDTH)

#define _BitmapLargeRowP(bmp,row) ((_BitmapDataP(bmp))+VT_LARGE_BITMAP_WIDTH*((row)*LARGE_HEIGHT))
#define _BitmapLargeText(bmp,row,c) (_BitmapLargeRowP(bmp,row)+((c)*LARGE_WIDTH*2))


#define _BitmapSmallRowR(bmp,row) (_BitmapDataR(bmp)+ROUNDUP(bmp->bmiHeader.biWidth)*(bmp->bmiHeader.biHeight-(row)*SMALL_HEIGHT))
#define _BitmapSmallChar(bmp,c)	(_BitmapSmallRowR(bmp,(c)/32)+((c)&0x1f)*SMALL_WIDTH)

#define _BitmapSmallRowP(bmp,row) ((_BitmapDataP(bmp))+VT_SMALL_BITMAP_WIDTH*((row)*SMALL_HEIGHT))
#define _BitmapSmallText(bmp,row,c) (_BitmapSmallRowP(bmp,row)+((c)*SMALL_WIDTH*2))


#define _MakePage(mag,page) (((mag)?(mag):8)*100+((page)>>4)*10+((page)&0xf))


#define MAXVTDIALOG 8

typedef struct TVTPage {
	WORD wCtrl;
	BOOL Fill;
	BYTE Frame[25][40];
    BYTE LineUpdate[25];
	BYTE bUpdated;
};

typedef struct TVT {
    unsigned short SubCount;
	struct TVTPage *SubPage;
};

struct TVT VTFrame[800];

int SubPage=0;

typedef struct TVTDialog {
	HWND Dialog;
	int  Page;
	int  SubPage;
	int  FramePos;
	BOOL Large;
	BOOL PageChange;
	unsigned char AsciiPuffer[26][40];
};

extern int VT_Cache;
extern BYTE VT_Header_Line[40];


extern struct TVTDialog VTDialog[MAXVTDIALOG];

extern BITMAPINFO *VTScreen[MAXVTDIALOG];
extern BITMAPINFO *pDIB;

extern unsigned short UTPages[12];
extern unsigned short UTCount;

extern unsigned short VTColourTable[9];
extern BITMAPINFO          *VTCharSetLarge ;
extern BITMAPINFO          *VTCharSetSmall;
extern BOOL Capture_VBI;
extern BOOL VTLarge;
extern HWND hWnd;
char Text[128];

extern int VBI_Flags;
#define VBI_VT  1
#define VBI_VPS 2
#define VBI_VC  4
#define VBI_IC  8
