#include <windows.h>       /* required for all Windows applications */
#include <stdio.h>
#include "resource.h"
#include "vt.h"

int New_Dialog_Slot(HWND hwnd);
int Get_Dialog_Slot(HWND hwnd);
int Del_Dialog_Slot(HWND hwnd);
void VT_ChannelChange();

int VT_GetPage(int nPage,BOOL *ErsteSub,int *SubNr)
{
int i;	
if(nPage<100 || nPage>899) return (-1);
if (VTFrame[nPage-100].SubCount==0 ) return(-1);
if ( *ErsteSub == TRUE ) {
     i=0;
	  while (( i < VTFrame[nPage-100].SubCount) && ( VTFrame[nPage-100].SubPage[i].Fill == FALSE )) i++;
      *SubNr=i;
}
*ErsteSub=FALSE;
return nPage-100;
}


void VT_DoUpdate_Page(int Page,int SubPage,int Dialog,BOOL bForceUpdate,int VTDisplayMode,BOOL Large)
{
	
	BOOL bGraph,bHoldGraph,bSepGraph,bBox,bFlash,bDouble,bConceal,bHasDouble;
	BYTE nLastGraph;
	unsigned short CurrentFg, CurrentBkg, RealBkg;
	WORD wCharHeight,wCharWidth;
	BYTE c,ch;
    int endrow;
	int n,row,x,y;
	char tmp[41];
	BITMAPINFO* pCharSet;
	char tmp2[9];
    int VT_Bitmap_width;

	BYTE* src, *dest;
	unsigned short* dest1;

	BOOL bHideTopLine,bForceShowTopLine;
	unsigned short Black,ForceBlack,ForceTransparent;


	if ( VTFrame[Page].SubCount == 0 ) {
        	Black=VTColourTable[0]; // 
			bHideTopLine=FALSE;
  		    ForceTransparent=VTColourTable[8];
	        ForceBlack=VTColourTable[0];
	} else {

	if((VTFrame[Page].SubPage[SubPage].wCtrl&(3<<4)) || VTDisplayMode == 1 )
		Black=VTColourTable[8];
	else
		Black=VTColourTable[0]; // 0

	ForceTransparent=VTColourTable[8];
	ForceBlack=VTColourTable[0];

	if(VTFrame[Page].SubPage[SubPage].wCtrl&(3<<4))
		bHideTopLine=TRUE;
	else
		bHideTopLine=FALSE;
	};

	if ( Large == TRUE ) {
		wCharWidth=LARGE_WIDTH;
		wCharHeight=LARGE_HEIGHT;
		pCharSet=VTCharSetLarge;
		VT_Bitmap_width=VT_LARGE_BITMAP_WIDTH;
	} else {
		wCharWidth=SMALL_WIDTH;
		wCharHeight=SMALL_HEIGHT;
		pCharSet=VTCharSetSmall;
		VT_Bitmap_width=VT_SMALL_BITMAP_WIDTH;
	};

	bForceShowTopLine=TRUE;

	bHasDouble=FALSE;
    endrow=25;

   	if ( VTFrame[Page].SubCount == 0 ) {
		endrow=1;
	} else {
    	if( VTFrame[Page].SubPage[SubPage].bUpdated == 0) endrow=1;
	}


	for(row=0; row<endrow ; row++)
	{
		if(bHasDouble) { bHasDouble=FALSE; continue; }
		bGraph=bHoldGraph=bSepGraph=bBox=bFlash=bDouble=bConceal=bHasDouble=FALSE;
		nLastGraph=32;

		
        if ( VTFrame[Page].SubCount == 0 ) {

		sprintf(tmp2,"  P%-3d \x7",VTDialog[Dialog].Page);
		for(n=0; n<40; n++)
		{
			tmp[n]=VT_Header_Line[n]&0x7f;
			if(tmp[n]==0x0d) bHasDouble=TRUE;
			strncpy(tmp,tmp2,8);
		}


		} else {

		for(n=0; n<40; n++)
		{
			tmp[n]=VTFrame[Page].SubPage[SubPage].Frame[row][n]&0x7f;
			if(tmp[n]==0x0d) bHasDouble=TRUE;
		}
		tmp[n]='\0';
		
		if(row==0)
		{
			sprintf(tmp2,"  P%-3d \x7",VTDialog[Dialog].Page);
			strncpy(tmp,tmp2,8);
		if ( VTFrame[Page].SubPage[SubPage].Fill == FALSE ) {
		for(n=0; n<40; n++)
		{
			tmp[n]=VT_Header_Line[n]&0x7f;
			if(tmp[n]==0x0d) bHasDouble=TRUE;
			strncpy(tmp,tmp2,8);
		}
		} else {
		for(n=30; n<40; n++)
		{
			tmp[n]=VT_Header_Line[n]&0x7f;
			if(tmp[n]==0x0d) bHasDouble=TRUE;
		}

		}
		}
		}

		RealBkg=ForceBlack;
		if ( Page != 0 ) { 
		if(row==0 && ((VTFrame[Page].SubCount==0) || (bForceShowTopLine || (!bHideTopLine && VTDisplayMode!=1))))
			CurrentBkg=ForceBlack;
		else
			CurrentBkg=Black;

		if((bHideTopLine && !bForceShowTopLine) && row==0 && (VTFrame[Page].SubCount > 0))
			memset(tmp,32,40);
        } else CurrentBkg=ForceBlack;

		CurrentFg=VTColourTable[7];
		for(n=0; n<40; n++)
		{
			c=tmp[n];
			ch=c;
			if(c<32)
			{
				if(c<8)
				{
					CurrentFg=VTColourTable[c];
					bGraph=FALSE;
				}
				if(c>=0x10 && c<=0x17)
				{
					bGraph=TRUE;
					CurrentFg=VTColourTable[c-0x10];
				}
				if(c==0x1d)
				{
					CurrentBkg=(bBox || Black!=ForceTransparent)?CurrentFg:ForceTransparent;
					RealBkg=CurrentFg;
				}
				if(c==0x1c)
				{
					CurrentBkg=bBox?ForceBlack:Black;
					RealBkg=ForceBlack;
				}
				if(c==0x08) bFlash=TRUE;
				if(c==0x09) bFlash=FALSE;
				if(c==0x0c) bDouble=FALSE;
				if(c==0x0d) bDouble=TRUE;
				if(c==0x18) bConceal=TRUE;
				if(c==0x19) bSepGraph=FALSE;
				if(c==0x1a) bSepGraph=TRUE;
				if(c==0x1e) bHoldGraph=TRUE;
				if(c==0x1f) bHoldGraph=FALSE;
				ch=bHoldGraph?nLastGraph:32;
			}
			if((CurrentFg==VTColourTable[7]) && (VTFrame[Page].SubCount==0) && (!row && n>7))
				CurrentFg=VTColourTable[2];
			nLastGraph=32;
			if(bGraph && (ch&0x20))
			{
				nLastGraph=ch;
				ch=(ch&0x1f)|((ch&0x40)>>1);
				ch+=96;
				if(bSepGraph) ch+=64;
			}
			else
				ch-=32;

		if (( ch >= 16 ) && ( ch <= 25 )) VTDialog[Dialog].AsciiPuffer[row][n]=ch+32;
		 else VTDialog[Dialog].AsciiPuffer[row][n]=0x00;
			
		 if( bDouble == TRUE ) {
		if (( ch >= 16 ) && ( ch <= 25 )) VTDialog[Dialog].AsciiPuffer[row+1][n]=ch+32;
		 else VTDialog[Dialog].AsciiPuffer[row+1][n]=0x00;
		 }


	if ( Large == TRUE ) src=_BitmapLargeChar(pCharSet,ch);
        else src=_BitmapSmallChar(pCharSet,ch);
		dest=_BitmapDataP(VTScreen[Dialog]);
		dest+= VTScreen[Dialog]->bmiHeader.biSizeImage;
        dest-=((40-n)*(wCharWidth*2))+((wCharWidth/2)*2);
        dest-=(row*VT_Bitmap_width*wCharHeight*2);


				for(y=0; y<((bDouble&&(row<24))?wCharHeight*2:wCharHeight); y++)
				{
					if(!bDouble || (bDouble&&(!(y&1))))
						src-=ROUNDUP(pCharSet->bmiHeader.biWidth);

					for(x=0; x<wCharWidth; x++) {
						(unsigned char *)dest1=(dest+x*2);
						*(dest1)=(unsigned short)(*(src+x)?CurrentFg:CurrentBkg);
					};
					dest-=VT_Bitmap_width*2;

				}
				if(!bDouble && bHasDouble && row<24)
				{
					for(y=0; y<wCharHeight; y++)
					{
						for(x=0; x<wCharWidth; x++) {
						(unsigned char *)dest1=(dest+x*2);
							*(dest1)=CurrentBkg;
						}
						dest-=VT_Bitmap_width*2;
					}

				}

			if(c<32)
			{
				if(c==0x0a) // Box off
				{
					CurrentBkg=(Black==ForceTransparent)?ForceTransparent:RealBkg;
					bBox=FALSE;
				}
				if(c==0x0b) // Box on
				{ 
					CurrentBkg=RealBkg;
					bBox=TRUE;
				}
			}
		}
	}
  }



void VT_ChannelChange()
{
int i;

for (i=0; i < 12; i++ ) UTPages[i]=0;
UTCount=0;

if (VBI_Flags&VBI_VT) {
				           VBI_Flags-=VBI_VT;
						   Sleep(2);Sleep(0);Sleep(2);Sleep(0);Sleep(2);
						   Sleep(2);Sleep(0);Sleep(2);Sleep(0);Sleep(2);
						   Sleep(2);Sleep(0);Sleep(2);Sleep(0);Sleep(2);
} else return;



for ( i=0; i < 800 ; i++ ) {
	VTFrame[i].SubCount=0;
	if ( VTFrame[i].SubPage != NULL  ) free(VTFrame[i].SubPage);
	VTFrame[i].SubPage=NULL;
	};
VT_Cache=0;
VBI_Flags+=VBI_VT;
}



BOOL APIENTRY VideoTextProc(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{

int Slot;
int i;
HDC wHDC;                          /* display-context variable  */
PAINTSTRUCT wps;                   /* paint structure           */
RECT rect;
int x,y;
char Buffer[10];
char Text[40];


	switch (message) {
        case WM_INITDIALOG:

 	SetDlgItemInt(hDlg,IDC_EDIT1,100,FALSE);
	Slot=New_Dialog_Slot(hDlg);
			if ( Slot < 0 ) {
				          MessageBox(hWnd,"Alle Videotext-Dialoge belegt","MULTI-Decoder",MB_ICONSTOP|MB_OK);
						  EndDialog(hDlg,0);
						  return(TRUE);
			
			};

         if ( VTScreen[Slot]!=NULL ) free(VTScreen[Slot]);
         VTScreen[Slot]=NULL;
 
		if ( VTLarge == TRUE ) {
		    VTScreen[Slot]=(BITMAPINFO*)calloc(1,sizeof(BITMAPINFOHEADER)+sizeof(WORD)*256+VT_LARGE_BITMAP_WIDTH*2*VT_LARGE_BITMAP_HEIGHT);
			VTScreen[Slot]->bmiHeader.biSize          = sizeof(pDIB->bmiHeader);
			VTScreen[Slot]->bmiHeader.biWidth         = VT_LARGE_BITMAP_WIDTH;
			VTScreen[Slot]->bmiHeader.biHeight        = VT_LARGE_BITMAP_HEIGHT;
			VTScreen[Slot]->bmiHeader.biPlanes        = 1;
			VTScreen[Slot]->bmiHeader.biBitCount      = 16;
			VTScreen[Slot]->bmiHeader.biCompression   = BI_RGB;
			VTScreen[Slot]->bmiHeader.biSizeImage     = VTScreen[Slot]->bmiHeader.biWidth    *
												  VTScreen[Slot]->bmiHeader.biHeight   *
												  VTScreen[Slot]->bmiHeader.biBitCount /
												  8;
			VTScreen[Slot]->bmiHeader.biXPelsPerMeter = 0;
			VTScreen[Slot]->bmiHeader.biYPelsPerMeter = 0;
			VTScreen[Slot]->bmiHeader.biClrUsed       = 0;
			VTScreen[Slot]->bmiHeader.biClrImportant  = 0;
		    VTDialog[Slot].Large=TRUE;	
		} else {
		    VTScreen[Slot]=(BITMAPINFO*)calloc(1,sizeof(BITMAPINFOHEADER)+sizeof(WORD)*256+VT_SMALL_BITMAP_WIDTH*2*VT_SMALL_BITMAP_HEIGHT);
			VTScreen[Slot]->bmiHeader.biSize          = sizeof(pDIB->bmiHeader);
			VTScreen[Slot]->bmiHeader.biWidth         = VT_SMALL_BITMAP_WIDTH;
			VTScreen[Slot]->bmiHeader.biHeight        = VT_SMALL_BITMAP_HEIGHT;
			VTScreen[Slot]->bmiHeader.biPlanes        = 1;
			VTScreen[Slot]->bmiHeader.biBitCount      = 16;
			VTScreen[Slot]->bmiHeader.biCompression   = BI_RGB;
			VTScreen[Slot]->bmiHeader.biSizeImage     = VTScreen[Slot]->bmiHeader.biWidth    *
												  VTScreen[Slot]->bmiHeader.biHeight   *
												  VTScreen[Slot]->bmiHeader.biBitCount /
												  8;
			VTScreen[Slot]->bmiHeader.biXPelsPerMeter = 0;
			VTScreen[Slot]->bmiHeader.biYPelsPerMeter = 0;
			VTScreen[Slot]->bmiHeader.biClrUsed       = 0;
			VTScreen[Slot]->bmiHeader.biClrImportant  = 0;
			VTDialog[Slot].Large=FALSE;
			};
			VTDialog[Slot].SubPage=0;
            VTDialog[Slot].PageChange = TRUE;
			SetTimer(hDlg,1,333,NULL);
            return(TRUE);
 
        case WM_TIMER:
			   if ( wParam != 1 ) return(TRUE);
			
			   sprintf(Text,"VT-Cache %d",VT_Cache);
			   SetDlgItemText(hDlg,IDC_TEXT21,Text);
			   
			   Slot=Get_Dialog_Slot(hDlg);
				if ( Slot < 0 ) {
				          MessageBox(hDlg,"Fehler :Unbekannter Videotext-Dialoge","MULTI-Decoder",MB_ICONSTOP|MB_OK);
						  EndDialog(hDlg,0);
						  return(TRUE);
			};
			   sprintf(Text,"%02d/%02d",VTDialog[Slot].SubPage+1,VTFrame[VTDialog[Slot].FramePos].SubCount);
			   SetDlgItemText(hDlg,IDC_TEXT20,Text);

				if (( VTDialog[Slot].Page >= 100 ) && ( VTDialog[Slot].Page <= 899 )) {

				    VTDialog[Slot].FramePos=VT_GetPage(VTDialog[Slot].Page,&VTDialog[Slot].PageChange,&VTDialog[Slot].SubPage);
					
                    if (( VTDialog[Slot].FramePos >= 0 ) &&
						( VTFrame[VTDialog[Slot].FramePos].SubPage[VTDialog[Slot].SubPage].bUpdated != 0 )) {
	
					VT_DoUpdate_Page(VTDialog[Slot].FramePos,VTDialog[Slot].SubPage,Slot,TRUE,0,VTDialog[Slot].Large);
					VTFrame[VTDialog[Slot].FramePos].SubPage[VTDialog[Slot].SubPage].bUpdated=0;
					sprintf(Text,"Seite %d gefunden",VTDialog[Slot].Page);
					SetDlgItemText(hDlg,IDC_TEXT,Text);
					SetDlgItemText(hDlg,IDC_EDIT1,"");

					sprintf(Text,"MultiDecode VT %d",VTDialog[Slot].Page);
					SetWindowText(hDlg,Text);

					rect.top=50;rect.left=10;
					rect.bottom=501;rect.right=637;
					InvalidateRect(hDlg,&rect,TRUE);
					} else {
						if ( VTDialog[Slot].FramePos < 0 ) {
							VT_DoUpdate_Page(VTDialog[Slot].Page-100,0,Slot,TRUE,0,VTDialog[Slot].Large);
						} else VT_DoUpdate_Page(VTDialog[Slot].FramePos,VTDialog[Slot].SubPage,Slot,TRUE,0,VTDialog[Slot].Large);
					rect.top=50;rect.left=10;
					rect.bottom=70;rect.right=637;
					InvalidateRect(hDlg,&rect,TRUE);

					};
					
				}
				break; 

       
		case IDM_VT_PAGE_MINUS:
           				Slot=Get_Dialog_Slot(hDlg);
                        if ( VTDialog[Slot].Page > 100 ) {
							 SetDlgItemInt(hDlg,IDC_EDIT1,VTDialog[Slot].Page-1 ,FALSE);
						     VTDialog[Slot].PageChange = TRUE;
						}
                        return(TRUE);

		case IDM_VT_PAGE_PLUS:
           				Slot=Get_Dialog_Slot(hDlg);
                        if ( VTDialog[Slot].Page > 100 ) {
							 SetDlgItemInt(hDlg,IDC_EDIT1,VTDialog[Slot].Page+1 ,FALSE);
						     VTDialog[Slot].PageChange = TRUE;
						}
                        return(TRUE);
        

		case WM_LBUTTONUP:
                  y=HIWORD( lParam );
			      x=LOWORD( lParam );
                  if (( x >= 83 ) && ( y >= 13 ) &&
                      ( x <= 107 ) && ( y <= 28 )) {
           				Slot=Get_Dialog_Slot(hDlg);
                        if ( VTDialog[Slot].Page > 100 ) {
							 SetDlgItemInt(hDlg,IDC_EDIT1,VTDialog[Slot].Page-1 ,FALSE);
						     VTDialog[Slot].PageChange = TRUE;
						}
                        return(TRUE);
				  }
                  if (( x >= 113 ) && ( y >= 13 ) &&
                      ( x <= 138 ) && ( y <= 28 )) {
           				Slot=Get_Dialog_Slot(hDlg);
                        if ( VTDialog[Slot].Page < 899 ) {
							SetDlgItemInt(hDlg,IDC_EDIT1,VTDialog[Slot].Page+1 ,FALSE);
						     VTDialog[Slot].PageChange = TRUE;
						}
							return(TRUE);

				  }
                  if (( x >= 143 ) && ( y >= 13 ) &&
                      ( x <= 168 ) && ( y <= 28 )) {
           				Slot=Get_Dialog_Slot(hDlg);
                        SetDlgItemInt(hDlg,IDC_EDIT1,100 ,FALSE);
						VTDialog[Slot].PageChange = TRUE;
                        return(TRUE);
				  }
                  if (( x >= 174 ) && ( y >= 4 ) &&
                      ( x <= 198 ) && ( y <= 19 )) {
           				Slot=Get_Dialog_Slot(hDlg);
						i=VTDialog[Slot].SubPage;
						if ( VTFrame[VTDialog[Slot].FramePos].SubCount == 0 ) return(TRUE);
                        i--;
						if ( i < 0 ) i=VTFrame[VTDialog[Slot].FramePos].SubCount-1;
						  while (( i>= 0 ) && ( VTFrame[VTDialog[Slot].FramePos].SubPage[i].Fill == FALSE )) i--;
                      if ( i >= 0 ) VTDialog[Slot].SubPage=i;
					  SetDlgItemInt(hDlg,IDC_EDIT1,VTDialog[Slot].Page ,FALSE);
					  return(TRUE);
				  }

                  if (( x >= 174 ) && ( y >= 20 ) &&
                      ( x <= 198 ) && ( y <= 35 )) {
           				Slot=Get_Dialog_Slot(hDlg);
						i=VTDialog[Slot].SubPage;
						if ( VTFrame[VTDialog[Slot].FramePos].SubCount == 0 ) return(TRUE);
                        i++;
						if ( i >= VTFrame[VTDialog[Slot].FramePos].SubCount ) i=0;
					    while (( i < VTFrame[VTDialog[Slot].FramePos].SubCount) && ( VTFrame[VTDialog[Slot].FramePos].SubPage[i].Fill == FALSE )) i++;
                      if ( i < VTFrame[VTDialog[Slot].FramePos].SubCount ) VTDialog[Slot].SubPage=i;
  					  SetDlgItemInt(hDlg,IDC_EDIT1,VTDialog[Slot].Page ,FALSE);

					  return(TRUE);
				  }
                  
           		  Slot=Get_Dialog_Slot(hDlg);

				  if ( VTDialog[Slot].Large == FALSE ) {
					  if (( y >= 50 ) && ( y <= 345 ) && ( x>=10 ) && ( x<=406 )) {
						  x=((x-10)/SMALL_WIDTH)-1;
						  y=(y-50)/SMALL_HEIGHT;
						  if (( x >= 0 ) && ( x <= 39 ) && ( y >= 0 ) && ( y <= 24 )) {
	                        i=0;
							Buffer[i]=0x00;
							while (( x >= 0 ) && ( VTDialog[Slot].AsciiPuffer[y][x] != 0x00 )) x--;
							if  ( x < 0 ) return(TRUE);
							if ( VTDialog[Slot].AsciiPuffer[y][x] == 0x00 ) x++;
							while (( i < 9 ) && ( x+i < 40 ) && (VTDialog[Slot].AsciiPuffer[y][x+i] != 0x00 )) {
								Buffer[i]=VTDialog[Slot].AsciiPuffer[y][x+i];
								i++;
								Buffer[i]=0x00;
							}
                            if ( i != 3 ) return(TRUE);
							i=atoi(Buffer);
           					if (( i < 100 ) || ( i > 899 )) return(TRUE);
				               
							   if ( i != VTDialog[Slot].Page )  VTDialog[Slot].PageChange=TRUE; 
							   VTDialog[Slot].Page = i;
					           sprintf(Text,"Suche Seite %d",VTDialog[Slot].Page);
                               SetDlgItemText(hDlg,IDC_TEXT,Text);
					           VTDialog[Slot].FramePos=VT_GetPage(VTDialog[Slot].Page,&VTDialog[Slot].PageChange,&VTDialog[Slot].SubPage);
						  }
					  }
                   return(TRUE);
				  };


				  if ( VTDialog[Slot].Large == TRUE ) {
					  if (( y >= 50 ) && ( y <= 498 ) && ( x>=10 ) && ( x<=606 )) {
						  x=((x-10)/LARGE_WIDTH)-1;
						  y=(y-50)/LARGE_HEIGHT;
						  if (( x >= 0 ) && ( x <= 39 ) && ( y >= 0 ) && ( y <= 24 )) {
	                        i=0;
							Buffer[i]=0x00;
							while (( x >= 0 ) && ( VTDialog[Slot].AsciiPuffer[y][x] != 0x00 )) x--;
							if  ( x < 0 ) return(TRUE);
							if ( VTDialog[Slot].AsciiPuffer[y][x] == 0x00 ) x++;
							while (( i < 9 ) && ( x+i < 40 ) && (VTDialog[Slot].AsciiPuffer[y][x+i] != 0x00 )) {
								Buffer[i]=VTDialog[Slot].AsciiPuffer[y][x+i];
								i++;
								Buffer[i]=0x00;
							}
                            if ( i != 3 ) return(TRUE);
							i=atoi(Buffer);
           					if (( i < 100 ) || ( i > 899 )) return(TRUE);
							   if ( i != VTDialog[Slot].Page )  VTDialog[Slot].PageChange=TRUE; 
				               VTDialog[Slot].Page = i;
					           sprintf(Text,"Suche Seite %d",VTDialog[Slot].Page);
                               SetDlgItemText(hDlg,IDC_TEXT,Text);
					           VTDialog[Slot].FramePos=VT_GetPage(VTDialog[Slot].Page-100,&VTDialog[Slot].PageChange,&VTDialog[Slot].SubPage);
						  }
					  }
				  };


                 break;
		case WM_PAINT:
                 wHDC = BeginPaint(hDlg,&wps);
				Slot=Get_Dialog_Slot(hDlg);
				if ( Slot < 0 ) {
				          MessageBox(hDlg,"Fehler :Unbekannter Videotext-Dialoge","MULTI-Decoder",MB_ICONSTOP|MB_OK);
						  EndDialog(hDlg,0);
						  return(TRUE);
			};
				if ( VTDialog[Slot].Large == TRUE ) {
	SetDIBitsToDevice( wHDC,
                      10,
                      50,
                      VT_LARGE_BITMAP_WIDTH,
                      VT_LARGE_BITMAP_HEIGHT,
                      0,
                      0,
                      0,
                      VT_LARGE_BITMAP_HEIGHT,
                      _BitmapDataP(VTScreen[Slot]),
					  VTScreen[Slot],
					  DIB_PAL_COLORS);
				} else {
	SetDIBitsToDevice( wHDC,
                      10,
                      50,
                      VT_SMALL_BITMAP_WIDTH,
                      VT_SMALL_BITMAP_HEIGHT,
                      0,
                      0,
                      0,
                      VT_SMALL_BITMAP_HEIGHT,
                      _BitmapDataP(VTScreen[Slot]),
					  VTScreen[Slot],
					  DIB_PAL_COLORS);
				}
                 EndPaint (hDlg,  &wps);
                 break;

        


		case WM_COMMAND:
            
			if ( (HWND)lParam==GetDlgItem(hDlg,IDC_EDIT1) ){
				Slot=Get_Dialog_Slot(hDlg);
				if ( Slot < 0 ) {
						  return(TRUE);
			};
				i=GetDlgItemInt(hDlg,IDC_EDIT1,NULL,FALSE);		  
                if (( i >= 100 ) && ( i <= 899 )) {
				    if ( i != VTDialog[Slot].Page )  VTDialog[Slot].PageChange=TRUE; 
					VTDialog[Slot].Page = i;
					sprintf(Text,"Suche Seite %d",VTDialog[Slot].Page);
                    SetDlgItemText(hDlg,IDC_TEXT,Text);
					VTDialog[Slot].FramePos=VT_GetPage(VTDialog[Slot].Page,&VTDialog[Slot].PageChange,&VTDialog[Slot].SubPage);
                    if ( VTDialog[Slot].FramePos >= 0 ) {
					VTFrame[VTDialog[Slot].FramePos].SubPage[VTDialog[Slot].SubPage].bUpdated =1;
					VT_DoUpdate_Page(VTDialog[Slot].FramePos,VTDialog[Slot].SubPage,Slot,TRUE,0,VTDialog[Slot].Large);
					VTFrame[VTDialog[Slot].FramePos].SubPage[VTDialog[Slot].SubPage].bUpdated =0;
					sprintf(Text,"%02d/%02d",VTDialog[Slot].SubPage+1,VTFrame[VTDialog[Slot].FramePos].SubCount);
					SetDlgItemText(hDlg,IDC_TEXT20,Text);
					sprintf(Text,"Seite %d gefunden",VTDialog[Slot].Page);
                    SetDlgItemText(hDlg,IDC_TEXT,Text);
					SetDlgItemText(hDlg,IDC_EDIT1,"");
					sprintf(Text,"MultiDecode VT %d",VTDialog[Slot].Page);
					SetWindowText(hDlg,Text);

					rect.top=50;rect.left=10;
					rect.bottom=501;rect.right=637;
					InvalidateRect(hDlg,&rect,FALSE);
					}

				}
			break;
			}
            

               if ( LOWORD(wParam) == IDCANCEL) {
                KillTimer(hDlg,1);
				Slot=Del_Dialog_Slot(hDlg);
				if ( Slot < 0 ) {
				          MessageBox(hDlg,"Fehler :Unbekannter Videotext-Dialoge","MULTI-Decoder",MB_ICONSTOP|MB_OK);
				} else {
                if ( VTScreen[Slot]!=NULL ) free(VTScreen[Slot]);
                 VTScreen[Slot]=NULL;
				}
                VTDialog[Slot].Dialog=NULL;
				Restore_Mode();
				EndDialog(hDlg,TRUE);
				 }

			 break;
    }
    return (FALSE);
        UNREFERENCED_PARAMETER(lParam);
}

int Get_Dialog_Slot(HWND hwnd)
{
	int i;
	for ( i = 0; i < MAXVTDIALOG; i++ ) {
		if ( hwnd == VTDialog[i].Dialog ) return(i);
	};

	return(-1);
};

int New_Dialog_Slot(HWND hwnd)
{
	int i;
	for ( i = 0; i < MAXVTDIALOG; i++ ) {
		if ( VTDialog[i].Dialog == NULL ) {
		    VTDialog[i].Dialog=hwnd;
			VTDialog[i].Page=0;
			VTDialog[i].SubPage=0;
            VTDialog[i].FramePos=-1;
			return(i);
		}
	};

	return(-1);
};

int Del_Dialog_Slot(HWND hwnd)
{
	int i;
	for ( i = 0; i < MAXVTDIALOG; i++ ) {
	if ( hwnd == VTDialog[i].Dialog )  {
		    VTDialog[i].Dialog=NULL;
			VTDialog[i].Page=0;
            VTDialog[i].FramePos=-1;
			return(i);
		}
	};

	return(-1);
};




