

#define ID_STATUSBAR    1700
#define ID_TEXTFIELD       ID_STATUSBAR+1
#define ID_KENNUNGFFIELD   ID_STATUSBAR+2
#define ID_CODEFIELD       ID_STATUSBAR+3
#define ID_FPSFIELD        ID_STATUSBAR+4
#define ID_AUDIOFIELD      ID_STATUSBAR+5

#define INIT_BT              1800
#define RESET_LIST           1802

#define MAXXRESO              724
#define MAXYRESO              288

int MasterTestzeilen=16;
int TZ[4];

extern BOOL NT;

BOOL DOSIZE=FALSE;


char CurrentDir[256];

HWND hWnd;
HANDLE hInst;

LONG APIENTRY MainWndProc(HWND, UINT, UINT, LONG);

int emsizex;
int emsizey;
int emstartx;
int emstarty;

BOOL SaveSettings=FALSE;

BOOL ALLWAYS_TOP=FALSE;

BOOL SplashShow;

BOOL Display_Status_Bar=TRUE;
BOOL InitStatusBar (HANDLE);
BOOL CreateStatusBar (HWND, HANDLE, int);
BOOL AdjustStatusBar (HWND);
HWND AddStatusField (HANDLE, int, int, int, BOOL);
BOOL DestroyStatusBar (void);

HWND    Status_Bar;
HWND    hwndTextField, hwndPalField;
HWND    hwndKeyField,hwndFPSField;
HWND    hwndAudioField;
 
RECT rectscreen;
RECT LastRect;


#define BT848_RISC_COUNT       0x120
#define BT848_DSTATUS          0x000
#define BT848_DSTATUS_PRES     (1<<7)
#define BT848_DSTATUS_HLOC     (1<<6)
#define BT848_DSTATUS_FIELD    (1<<5)
#define BT848_DSTATUS_NUML     (1<<4)
#define BT848_DSTATUS_CSEL     (1<<3)
#define BT848_DSTATUS_LOF      (1<<1)
#define BT848_DSTATUS_COF      (1<<0)

#define BT848_FCNTR             0x0E8

#define BT848_SRESET           0x07C

#define BT848_IFORM            0x004  
#define BT848_IFORM_HACTIVE    (1<<7)
#define BT848_IFORM_MUXSEL     (3<<5)
#define BT848_IFORM_MUX0       (2<<5)
#define BT848_IFORM_MUX1       (3<<5)
#define BT848_IFORM_MUX2       (1<<5)
#define BT848_IFORM_XTSEL      (3<<3)
#define BT848_IFORM_XT0        (1<<3)
#define BT848_IFORM_XT1        (2<<3)
#define BT848_IFORM_XTAUTO     (3<<3)
#define BT848_IFORM_XTBOTH     (3<<3)
#define BT848_IFORM_NTSC       1
#define BT848_IFORM_PAL_BDGHI  3
#define BT848_IFORM_PAL_M      4
#define BT848_IFORM_PAL_N      5
#define BT848_IFORM_SECAM      6
#define BT848_IFORM_AUTO       0
#define BT848_IFORM_NORM       7

typedef unsigned long PHYS;

PHYS    RiscBasePhysical; 
PHYS    DiplayPhysical; 
DWORD  *RiscBaseLinear;
DWORD  *pDiplayLinear;

DWORD BurstOffset=154;

WD_DMA Risc_dma;
WD_DMA Vbi_dma[5];
WD_DMA *Display_dma[5];
WD_DMA *Surface_dma;
WD_DMA *Overlay_dma;
WD_DMA Burst_dma[5];

HANDLE Bt848Device=NULL;
BOOL BTOK=FALSE;

BOOL USETUNER=TRUE;
BOOL USECARD=TRUE;

#define MAXVTDIALOG 8


typedef struct TVTDialog {
	HWND Dialog;
	int  Page;
	int  SubPage;
	int  FramePos;
	BOOL Large;
	BOOL PageChange;
	unsigned char AsciiPuffer[26][40];
};

struct TVTDialog VTDialog[MAXVTDIALOG];

BOOL VTLarge=TRUE;

extern int VT_Cache;


HANDLE OutThread;

int CountryCode=0;
int CurrentProgramm;
int EditProgramm;
/// Neu

typedef struct TCountries
{
        // Device data
        char Name[128];
};

struct TCountries Countries[35];


#define MAXPROGS 4096

    unsigned long freq;
    char Typ;
	unsigned int srate;         


typedef struct TProgramm
{
	char Name[20];
    unsigned long freq;
    char Typ;
	unsigned int srate;         
	int qam;               
	int fec;   
	int norm;
	unsigned short video_pid;        
	unsigned short audio_pid;
    unsigned short tt_pid;          /* Teletext PID */
    BOOL  Tuner_Auto;
    int power;             /* LNB power 0=off/pass through, 1=on */
	int volt;              /* 14/18V (V=0/H=1) */
	int afc;
	int ttk;               /* 22KHz */
	int diseqc;            /* Diseqc input select */
	unsigned short PMT;
	unsigned char   BW;
    unsigned short  PCR_pid;
	unsigned short  PMC;
	unsigned char   TVType; //  == 00 PAL ; 11 == NTSC    
	unsigned char   ServiceTyp;   
};

struct TProgramm Programm[MAXPROGS+1];


int m_dwDisplaySize=0;
BYTE  *pDisplay[5] =  { NULL,NULL,NULL,NULL,NULL  };
unsigned short  *pDecode=NULL;

int TVFormat;
int ColourFormat;
int S_ColourFormat;
int AudioSource;
int VideoSource;

BOOL VCIRQSync=FALSE;

BOOL Flip=1; 

int UTLoop=0;
int UTPage=150;

int MoveXDist=-1;
int MoveYDist=-1;

short HQTabelle[345*4*4];

/// VideoText
unsigned short VTColourTable[9];

BITMAPINFO          *VTCharSetLarge                    = NULL;
BITMAPINFO          *VTCharSetSmall                    = NULL;
BITMAPINFO          *VTScreen[MAXVTDIALOG];

int WindowStyle = 0;
long WStyle;

extern char IC_BASE_DIR[128];
extern char VD_DIR[128];

BOOL Show_Menu=TRUE;
HMENU hMenu;
HANDLE          hAccel;

extern int CurrentCapture;

int InitialProg=-1;
 
unsigned long InitialFreq;
unsigned char InitialHue=0x00;
unsigned char InitialBrightness=0x00;
unsigned char InitialIFORM=0x00;
int InitialContrast=0xd8;
int LastSaturation=0x00;
int InitialSaturationU=0xfe;
int InitialSaturationV=0xb4;
unsigned char THue=0x00;
unsigned char TBrightness=0x00;
int TContrast=0xd8;
int TSaturationU=0xfe;
int TSaturationV=0xb4;
int InitialLow=45;

int InitialVolume=1000;
char InitialBalance=0x00;
char InitialSpecial=0x00;
char InitialLoudness=0x00;
char InitialBass=0x00;
char InitialTreble=0x00;
BOOL InitialSuperBass=FALSE;
char InitialEqualizer1=0x00;
char InitialEqualizer2=0x00;
char InitialEqualizer3=0x00;
char InitialEqualizer4=0x00;
char InitialEqualizer5=0x00;
BOOL MSPToneControl=FALSE;
char InitialSpatial=0x00;


char TEqualizer1;
char TEqualizer2;
char TEqualizer3;
char TEqualizer4;
char TEqualizer5;

BOOL TSuperBass;
int  TVolume=1000;
char TBalance=0x00;
char TSpecial=0x00;
char TLoudness=0x00;
char TBass=0x00;
char TTreble=0x00;

BOOL Has_MSP=FALSE;

HWND SplashWnd;


struct TPacket30
{
	// Type 0 data

	struct
	{
		unsigned nMag:3;
		unsigned nPage:8;
		unsigned:5; // Unused
		WORD nSubcode;
	} HomePage;
	WORD NetId;
	struct
	{
		char Offset;
		DWORD JulianDay;
		BYTE Hour;
		BYTE Min;
		BYTE Sec;
	} UTC;
	char Unknown[5];
	char Identifier[21];

	// Type 2 data
	
	struct
	{
		unsigned LCI:2;
		unsigned LUF:1;
		unsigned PRF:1;
		unsigned PCS:2;
		unsigned MI:1;
		unsigned day:5;
		unsigned month:4;
		unsigned hour:5;
		unsigned minute:6;
		unsigned:5;
		WORD CNI;
		WORD PTY;
	} PDC;
};

struct TPacket30 Packet30;

typedef struct TVTPage {
	WORD wCtrl;
	BOOL Fill;
	BYTE Frame[25][40];
    BYTE LineUpdate[25];
	BYTE bUpdated;
};

typedef struct TVT {
    unsigned short SubCount;
	struct TVTPage *SubPage;
};

extern struct TVT VTFrame[800];


struct TTVSetting
{
	WORD wCropWidth,wCropHeight;
	WORD wTotalWidth;
	BYTE bDelayA,bDelayB,bIForm;
	DWORD dwXsfNum,dwXsfDen;
	WORD wHDelayx1,wHActivex1;
	WORD wVDelay;
	WORD wCropOffset;
};

struct TTunerType
{
  WORD thresh1; /* frequency Range for UHF,VHF-L, VHF_H */   
  WORD thresh2;  
  BYTE VHF_L;
  BYTE VHF_H;
  BYTE UHF;
  BYTE config; 
  BYTE I2C;
  WORD IFPCoff;
};

extern BOOL AutoStereoSelect;
extern int MSPMode;
extern int MSPStereo;
extern int MSPMajorMode;
extern int MSPMinorMode;


extern struct TTunerType Tuners[9];

extern unsigned int ManuellAudio[8];


struct DVBTunertype 
{
	char *name;
	unsigned char Vendor;
	unsigned char Type;
  
	/* all frequencies in units of Hz */
	unsigned long min;     /* minimum frequency */  
	unsigned long max;     /* maximum frequency */
	unsigned long res;     /* frequency resolution in Hz */
	unsigned long step;    /* stepsize in Hz (units of setfrequency ioctl) */
	unsigned long IFPCoff; /* frequency offset */
	unsigned long thresh1; /* frequency Range for UHF,VHF-L, VHF_H */   
	unsigned long thresh2;  
	unsigned char VHF_L;   
	unsigned char VHF_H;
	unsigned char UHF;
	unsigned char config; 
	unsigned char I2C;      /* most probable I2C address */
	unsigned char mode; /* mode change value (tested PHILIPS_SECAM only) */
	         /* 0x01 -> ??? no change ??? */
	         /* 0x02 -> PAL BDGHI / SECAM L */
	         /* 0x04 -> ??? PAL others / SECAM others ??? */
};

extern struct DVBTunertype DVBTuners[3];





struct TTVSetting TVSettings[8] =
{
	/* PAL-BDGHI */
	{ 768, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_BDGHI|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20, 0 },
	/* NTSC */
	{ 640, 480,  910, 0x68, 0x5d, (BT848_IFORM_NTSC|BT848_IFORM_XT0),
	    780, 640, 135, 754, 0x16, 0},
	/* SECAM */
	{ 768, 576, 1135, 0x7f, 0xb0, (BT848_IFORM_SECAM|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20},
	/* PAL-M */
	{ 640, 480, 910, 0x68, 0x5d, (BT848_IFORM_PAL_M|BT848_IFORM_XT0),
	    780, 640, 186, 922, 0x16, 0},
	/* PAL-N */
	{ 768, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_N|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20, 0},

	/* The Nagra Screen Burst*/
	{ 922, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_BDGHI|BT848_IFORM_XT1),
	    944, 822, 110, 998, 0x20, 0 },

	/* The 800x600 Special Screen */
	{ 800, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_BDGHI|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x20, 0 },

		/* PAL-BDGHI VideoDat-Receiver*/ 
	{ 768, 576, 1135, 0x7f, 0x72, (BT848_IFORM_PAL_BDGHI|BT848_IFORM_XT1),
	    944, 768, 186, 922, 0x26, 0 },

};

char ChannelString[10];

char BTTyp[30];
char MSPStatus[30];
char TunerStatus[30];


int CardType;
int TunerType;
int VideoSource;
int TVTYPE;
int S_TVTYPE;

int LastFrame;


BOOL Capture_Video = TRUE;
BOOL Capture_VBI=TRUE;
BOOL Capture_Pause=FALSE;
BOOL OutDib=TRUE;
BOOL ModeOverlay=FALSE;
UINT  WTVBPP=0;
BOOL WAIT_DX_VBI=FALSE;
BOOL USE_DX_LOCK=FALSE;
BOOL USE_DX_OV_STRECH=TRUE;

LPVOID                 lpSurface=NULL;
LPVOID                 lpOverlay=NULL;
LPDIRECTDRAW	lpDD;
extern BOOL Can_Overlay;
extern BOOL Can_Overlay_Strech;
extern LPDIRECTDRAWSURFACE     lpDDSurface;
extern LPDIRECTDRAWSURFACE     lpDDOverlay;


BOOL bFullscreen=FALSE;

int Offset_for_WindowOut;
int CurrentX,CurrentY;
int Res_X,Res_Y;

struct TKEY {
	    char Name[20];
		char Extension[4];
};

struct TKEY OPKEY[4];

int ActiveKey=0;

int ShowY;
int SurfacePitch;
int OverlayPitch;
int DibPitch;
int nPixelSchritt;
int nPixelStart;

unsigned char *pBurstLine[5];


// Decoding Stuff
BOOL DecodeNagra=FALSE;
BOOL NagraFullField = FALSE;
BOOL DecodeVCrypt=FALSE;
BOOL DecodeDecoderVCrypt=FALSE;

HDC  DIB_Hdc;

// Nagravision Stuff 
#define TESTPIXEL             32
#define ZEILENZAHL           287

int MovieBoost;
//int Old_MovieBoost=0;
int MovieScale=0;
int MaxY;
int MaxX;

BOOL Chroma_Key=TRUE;

HANDLE My_Heap;

extern DWORD GlobalJump;



int VCLmargin=10;

int                FORMAT_MASK           =  0x0F;
#define            FORMAT_4_3               0x08
#define            FORMAT_14_9              0x01
#define            FORMAT_16_9              0x0B
int PalFormat = 0;

__int64  CurrentLowValue    = 0x002d002d002d002d;

BOOL useSound=FALSE;
BOOL canSound;

BOOL MoreLinesLock=FALSE;
int  FirstWidthEven=TESTPIXEL;
int  FirstWidthOdd=TESTPIXEL;
int  FirstWidthEvenCount=0;
int  FirstWidthOddCount=0;

BOOL Line286BlackEven=FALSE;
BOOL Line286BlackOdd=FALSE;
BOOL Line285BlackEven=FALSE;
BOOL Line285BlackOdd=FALSE;
BOOL Line0BlackEven=FALSE;
BOOL Line0BlackOdd=FALSE;
BOOL Line1BlackEven=FALSE;
BOOL Line1BlackOdd=FALSE;
int B0e;
int B1e;
int B285e;
int B286e;
int B0o;
int B1o;
int B285o;
int B286o;
BOOL MatrixModeEven=FALSE;
BOOL MatrixModeOdd=FALSE;
int MatrixLinesEven=0;
int MatrixLinesOdd=0;
int MatrixCountEven=0;
int MatrixCountOdd=0;
int AutoLockCount=0;
int BlackEven=-1;
int BlackOdd=-1;
int UntilEven=0;
int UntilOdd=0;


char OrgDriverName[128];
char OrgDVBDriverName[128];

BOOL Has_BT=FALSE;
BOOL Has_DVB=FALSE;

extern int pSortLinesEven[ZEILENZAHL];
extern int pSortLinesOdd[ZEILENZAHL];

int Current_Mode=0;

int  nPALplusZeile  = -10;
int  nPALplusData   =  0;
int    BLData =  0;

BOOL  BlackSet[288];


BYTE INIT_PLL = 0; 
const __int64 nMaske    = 0x00ff00ff00ff00ff;
const __int64 One       = 0x0001000100010001;

int NextFrame=1;
int CurrentFrame=1;

// VC

extern HANDLE Decode_Event;

int OldMode;

BOOL AutoDetect_Nagra=TRUE;
BOOL AutoDetect_VC=TRUE;

BOOL Decode_AutoDetect;
int msgx=0;
BOOL Decode_AutoLock;
BOOL Auto_MovieBoost=TRUE;
BOOL AutoMovieBoostEnable=FALSE;

BOOL ModeRAWSurface=FALSE;
BOOL ModeRAWOverlay=FALSE;


extern int CurrentIrq;

 __int64  Black=0x8000800080008000;
 __int64  nMinus128 = 0x8000800080008000;
 __int64  nFaktoren = 0xf2fe20491989f9bf;
 __int64  nMaskeUV = 0xFF00FF00FF00FF00;

short HQLinebufferEven[846*8];
short *HQLinebufferEvenPtr=HQLinebufferEven;
short HQLinebufferOdd[846*8];
short *HQLinebufferOddPtr=HQLinebufferOdd;

extern unsigned short cp_odd[256][285];
 
short VCHQTabelleBurst[710*4*2];
short VCHQTabelleNoBurst[710*4*2];


BOOL HalfTVMode=FALSE;
BOOL Toggle_WithOut_Frame=FALSE;

BOOL Sync_Irq=FALSE;
extern BOOL VD_RAW;
extern int VBI_FPS;

int VBI_Flags=3;
#define VBI_VT  1
#define VBI_VPS 2
#define VBI_VC  4
#define VBI_IC  8
#define VBI_VD  16

int CryptMode;
extern	char VPS_chname[9];
extern 	char VPS_lastname[9];

typedef struct TCryptInfo  {
       int CryptMode;
	   int LastCryptMode;
	   unsigned char OSD0[10];
       unsigned char OSD1[10];
       unsigned char MSG0[10];
       unsigned char MSG1[10];
   	   BYTE OSD0Set;
	   BYTE OSD1Set;
	   BYTE MSG0Set;
	   BYTE MSG1Set;

};

struct TCryptInfo CryptInfo;


HWND ShowPDCInfo=NULL;
HWND ShowVTInfo=NULL;
HWND ShowVPSInfo=NULL;

extern unsigned short UTPages[12];
extern unsigned short UTCount;


// HC_ColorOptionen

BOOL HCInit15=FALSE;
BOOL InvertRot=FALSE;
BOOL InvertGruen=FALSE;
BOOL InvertBlau=FALSE;
BOOL OffRot=FALSE;
BOOL OffGruen=FALSE;
BOOL OffBlau=FALSE;
BOOL HCMode1=FALSE;
BOOL HCMode2=FALSE;


short HCSchwelle=0x00;
short HCRotFaktor=0x00;
short HCGruenFaktor=0x00;
short HCBlauFaktor=0x00;
short HCCutFaktor=0x00;
short HCCutHiRotFaktor=0x00;
short HCCutHiGruenFaktor=0x00;
short HCCutHiBlauFaktor=0x00;
short HCCutLoRotFaktor=0x00;
short HCCutLoGruenFaktor=0x00;
short HCCutLoBlauFaktor=0x00;

BOOL ColorMix=FALSE;
unsigned short HCYUV2RGBTabelle[64*64*64];

int HardWareFound=0;

HWND UTList;
LOGFONT lf = {16,0,0,0,400,0,0,0,0,0,0,0,0,"MS Sans Serif"};   
HFONT currFont;

struct TUT {
	char Zeile[240];
    short Fg;
	short Bg;
};

struct TUT UT[128];

char VTtoAscii[96] = { 
	" !##$%&()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ#-abcdefghijklmnopqrstuvwxyz#" };

extern int VBI_lpf;
int BeforeVD=0;

// Neues MenuHandling
int MenuFlip;
BOOL MenuOutDib;
BOOL MenuModeOverlay;
BOOL MenuModeRAWSurface;
BOOL MenuModeRAWOverlay;
BOOL MenuSave=FALSE;

struct TVDat {
	    int Status;
		int LastKillPos;
        int Interleave;
		int Lenght;
		int Pos;
		int Blockzaehler;
		int CRCError;
		int BlockSoFar;
    	unsigned char eLBN;
		unsigned char SOB1;
        unsigned char SOB2;
        unsigned char ADR;
        unsigned char SYS;
        unsigned char LBN;
        unsigned char KEY;
        unsigned char XDATA[1024];   //ARRAY of Byte...
        unsigned char CSL;
        unsigned char CSH;
        int Fehler_Frei;
		char FileName[13];
		unsigned int FileSize;
		FILE *FilePtr;

    int Index;
	char RawName[128];
	unsigned int BlocksOK;
	unsigned int BlocksError;
	char Error[512];
};

extern struct TVDat VDat;

typedef struct SOTREC  {
	unsigned int  date;   //Datum der Ausstrahlung...
    unsigned short fanz;          //Anzahl der bertragenden Dateien.
 	char           GeneralName[512];  
	char           ExecCommand[512];  
    char           Kommentar[512];    
};

extern struct SOTREC SOTInfoRec;

struct TInterCast {
  unsigned char blocks[28*16];
  unsigned char data[0x100];
  unsigned char *fbuf;
  unsigned int packnum, packtot, packlen, total;
  int datap, ok, esc, ciok;
  unsigned char ci,lastci;  /* ci = continuity index */
  unsigned short dat;
  unsigned int length;
  unsigned int done, flength;
  int pnum;
  char *name;
  int fbufSize;
  char Error[64];
  char fname[512];
  unsigned int BytesSoFar;

};

extern struct TInterCast InterCast;

extern BOOL System_In_Mute=FALSE;


// Mixer
extern int DeviceAnzahl;
extern MIXERCAPS *MixerDev;
extern MIXERLINE *MixerLine;
extern char InitialMixer[MAXPNAMELEN]; 
extern char InitialMixerLine[MIXER_LONG_NAME_CHARS]; 
extern char InitialMixerConnect[MIXER_LONG_NAME_CHARS]; 
extern int CurrentLine;
extern int CurrentMixer;
extern int CurrentConnect;



struct TMixerAccess {
    int SoundSystem;
    int Destination;
    int Connection;
    int Control;
};

struct TMixerValues {
    int Kanal1;
    int Kanal2;
    int Kanal3;
    int Kanal4;
};


struct TMixerAccess Volume={-1,0,0,0};
struct TMixerAccess Mute={-1,0,0,0};

struct TMixerLoad {
    	struct TMixerAccess MixerAccess;
        struct TMixerValues MixerValues;
};
struct TMixerLoad MixerLoad[64];

struct TMixerControls {
             int AnzahlControls;
	         MIXERCONTROL          *MixerControl;
             MIXERCONTROLDETAILS   *MixerDetail;
};

struct TMixerConnections {
	        int AnzahlConnections;
			MIXERLINE *MixerConnections;
			struct TMixerControls *To_Control;
};


struct TMixerLines {
	        int AnzahlLines;
			MIXERLINE *MixerLine;
			struct TMixerConnections *To_Connection;
};

BOOL DoWriteFrame=FALSE;
int WriteIndex=1;

struct TSoundSystem {
	    int DeviceAnzahl;
        MIXERCAPS *MixerDev;
		struct TMixerLines *To_Lines;
};


extern struct TSoundSystem SoundSystem;


BOOL USE_MIXER=FALSE;
int  MIXER_LINKER_KANAL=-1;
int  MIXER_RECHTER_KANAL=-1;
int MixerVolumeStep=-1;
int MixerVolumeMax=-1;

// Fantasio for Secam-Extensions
short NullTable[4] = {8192, 0, 0, 8192};
int	iUFilterThresholdPCent=70;  // Should start at 70 %
int	iVFilterThresholdPCent=70;  // Should start at 70 %
int TVFilter;
int TUFilter;



// CALL-Test
short *ScreenPtr;
short *TmpPtr;
short *ColFaktor;
int LinesAnzahl;
int BytesOut;
int CurrentPitch;

int AnzahlProzessor=1;
int MainProzessor=0;
int IrqProzessor=0;
int VBIProzessor=0;
int AusgabeProzessor=0;
int ProzessorMask;

#define CLEARLINES 288

extern short ZeilenPuffer[844];
short *pLinesDstAddressEven[CLEARLINES];
short *pLinesDstAddressOdd[CLEARLINES];
short *pLinesAddressEven[5*CLEARLINES];
short *pLinesAddressOdd[5*CLEARLINES];
short LinesOutEven[CLEARLINES];
short LinesOutOdd[CLEARLINES];
short RealOffset[287];

extern int referenzes[16];

int ResetIrq=0;

int VCFirstLine;
int VCTotalLines;
BOOL bFilterBlueLines=FALSE;


// DVB
extern int DVBTuner;
extern int DVBType;
char DVBTyp[30];
HANDLE		Device_Handle;
WD_DMA rps0_mem_dma;
WD_DMA debi_mem_dma;
WD_DMA *DVB_Display_dma[2];

unsigned int InitialDVBBrightness=0x80;
unsigned int InitialDVBContrast=0x40;
unsigned int InitialDVBColor=0x40;
unsigned int TColor;
extern unsigned int InitialDVBVolumeLinks=0x45;
extern unsigned int InitialDVBVolumeRechts=0x45;
unsigned int TVolumeLinks=0;
unsigned int TVolumeRechts=0;

extern BOOL Keep_DVB_Loaded;
extern unsigned int FirmID;

typedef struct OTLNB {
	     BOOL Power;
		 BOOL Switch22khz;
         unsigned int LofLow;
         unsigned int LofHigh;
		 unsigned int SwitchFreq;
};

struct TLNB {
	   BOOL Diseq;
	   struct OTLNB Anschluss[4];
} ;

struct TLNB LNB;



struct TTransponder {
	    BOOL Tuner_Auto;
		int ttk;
        int power;
		int diseqc;
        unsigned int freq;
        int volt;
        int qam;
        unsigned int srate;
        int fec;
    	int sync;              /* sync from decoder */
    	int afc;               /* frequency offset in Hz */
	    unsigned short agc;             /* gain */
	    unsigned short nest;            /* noise estimation */
        unsigned short vber;            /* viterbi bit error rate */
	};

struct TTransponder Transponder;

unsigned int SRates[10] = { 27500,22000,0,0,0,0,0,0,0,0 };